import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'dart:ui' as ui show BoxHeightStyle, BoxWidthStyle;

import 'package:mask_text_input_formatter/mask_text_input_formatter.dart';

class MaskedTextField extends TextField {
  MaskedTextField({
    Key? key,
    String? mask,
    Map<String, RegExp>? maskFilter,
    TextAlign textAlign = TextAlign.start,
    bool autocorrect = true,
    Iterable<String>? autofillHints = const [],
    bool autofocus = false,
    InputCounterWidgetBuilder? buildCounter,
    Clip clipBehavior = Clip.hardEdge,
    TextEditingController? controller,
    Color? cursorColor,
    double? cursorHeight,
    Radius? cursorRadius,
    double cursorWidth = 2.0,
    InputDecoration? decoration,
    DragStartBehavior dragStartBehavior = DragStartBehavior.start,
    bool? enabled,
    bool enableIMEPersonalizedLearning = true,
    bool? enableInteractiveSelection,
    bool enableSuggestions = true,
    bool expands = false,
    FocusNode? focusNode,
    List<TextInputFormatter>? inputFormatters,
    Brightness? keyboardAppearance,
    TextInputType? keyboardType,
    int? maxLength,
    MaxLengthEnforcement? maxLengthEnforcement,
    int? maxLines,
    int? minLines,
    MouseCursor? mouseCursor,
    bool obscureText = false,
    String obscuringCharacter = "*",
    AppPrivateCommandCallback? onAppPrivateCommand,
    ValueChanged<String>? onChanged,
    VoidCallback? onEditingComplete,
    ValueChanged<String>? onSubmitted,
    GestureTapCallback? onTap,
    bool readOnly = false,
    String? restorationId,
    bool scribbleEnabled = true,
    ScrollController? scrollController,
    EdgeInsets scrollPadding = const EdgeInsets.all(20),
    ScrollPhysics? scrollPhysics,
    TextSelectionControls? selectionControls,
    ui.BoxHeightStyle selectionHeightStyle = ui.BoxHeightStyle.tight,
    ui.BoxWidthStyle selectionWidthStyle = ui.BoxWidthStyle.tight,
    bool? showCursor,
    SmartDashesType? smartDashesType,
    SmartQuotesType? smartQuotesType,
    StrutStyle? strutStyle,
    TextStyle? style,
    TextAlignVertical? textAlignVertical,
    TextCapitalization textCapitalization = TextCapitalization.none,
    TextDirection? textDirection,
    TextInputAction? textInputAction,
    ToolbarOptions? toolbarOptions,
  }) : super(
            key: key,
            textAlign: textAlign,
            autocorrect: autocorrect,
            autofillHints: autofillHints,
            autofocus: autofocus,
            buildCounter: buildCounter,
            clipBehavior: clipBehavior,
            controller: controller,
            cursorColor: cursorColor,
            cursorHeight: cursorHeight,
            cursorRadius: cursorRadius,
            cursorWidth: cursorWidth,
            decoration: decoration,
            dragStartBehavior: dragStartBehavior,
            enabled: enabled,
            enableIMEPersonalizedLearning: enableIMEPersonalizedLearning,
            enableInteractiveSelection: enableInteractiveSelection,
            enableSuggestions: enableSuggestions,
            expands: expands,
            focusNode: focusNode,
            inputFormatters: [
              ...?inputFormatters,
              MaskTextInputFormatter(
                mask: mask,
                filter: maskFilter
              )
            ],
            keyboardAppearance: keyboardAppearance,
            keyboardType: keyboardType,
            maxLength: maxLength,
            maxLengthEnforcement: maxLengthEnforcement,
            maxLines: maxLines,
            minLines: minLines,
            mouseCursor: mouseCursor,
            obscureText: obscureText,
            obscuringCharacter: obscuringCharacter,
            onAppPrivateCommand: onAppPrivateCommand,
            onChanged: onChanged,
            onEditingComplete: onEditingComplete,
            onSubmitted: onSubmitted,
            onTap: onTap,
            readOnly: readOnly,
            restorationId: restorationId,
            scribbleEnabled: scribbleEnabled,
            scrollController: scrollController,
            scrollPadding: scrollPadding,
            scrollPhysics: scrollPhysics,
            selectionControls: selectionControls,
            selectionHeightStyle: selectionHeightStyle,
            selectionWidthStyle: selectionWidthStyle,
            showCursor: showCursor,
            smartDashesType: smartDashesType,
            smartQuotesType: smartQuotesType,
            strutStyle: strutStyle,
            style: style,
            textAlignVertical: textAlignVertical,
            textCapitalization: textCapitalization,
            textDirection: textDirection,
            textInputAction: textInputAction,
            toolbarOptions: toolbarOptions);
}
